Ruby - Bug #13793

Compatible issue with keyword args behavior
08/09/2017 06:09 AM - hsbt (Hiroshi SHIBATA)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: Backport: 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4:

UNKNOWN

Description
| found breaking changes for keyword args with Ruby 2.5.1

Reproduction instructions:

e git clone git@github.com:bundler/bundler.git
e gemirspec
¢ cd bundler && rspec spec/commands/viz_spec.rb:13

Ruby 2.4.1:

~/D/g/b/bundler (master) > rspec spec/commands/viz_spec.rb:13

Run options:
include {:locations=>{"./spec/commands/viz_spec.rb"=>[13]}}
exclude {:bundler=>"=< 1.15", :rubygems_master=>true, :git=>"=< 2.14.0",
rruby=>"=< 2.4.1", :realworld=>true, :sudo=>true}

bundle viz
graphs gems from the Gemfile

Retried examples: 0

Finished in 3.35 seconds (files took 1.37 seconds to load)
1 example, 0 failures

Ruby 2.5.0(ruby 2.5.0dev (2017-08-08 trunk 59529) [x86_64-darwin16])

~/D/g/b/bundler (master) > rspec spec/commands/viz_spec.rb:13

Run options:
include {:locations=>{"./spec/commands/viz_spec.rb"=>[13]}}
exclude {:bundler=>"=< 1.15", :rubygems_master=>true, :git=>"=< 2.14.0",
rruby=>"=< 2.5.0", :realworld=>true, :sudo=>true}

bundle viz

:rubygems=>"=< 2.6.11",

:rubygems=>"=< 2.6.12",

(snip)
ArgumentError: unknown keyword: png
/path/to/bundler/bundler/tmp/gems/system/gems/ruby—-graphviz-1.2.3/1lib/graphviz.rb:441:in
‘output'
/path/to/bundler/bundler/lib/bundler/graph.rb:142:in " run'
(snip)

| also reported bundler's tracker: https:/github.com/bundler/bundler/issues/5939

Related issues:
Related to Ruby - Bug #13791: “belongs_to': unknown keywords: required, anony... Closed
Related to Ruby - Bug #10856: Splat with empty keyword args gives unexpected ... Closed

Associated revisions

Revision 059¢f260e72bace987bf4e1fc09733b576547¢c67 - 08/10/2017 12:50 AM - nobu (Nobuyoshi Nakada)
compile.c: fix KW_SPLAT flag condition

07/16/2025

1/2



mailto:git@github.com
https://github.com/bundler/bundler/issues/5939

e compile.c (compile_array_keyword_arg): fix the condition of
KW_SPLAT flag. splat is value node only without key node,

simple assoc argument is not. [ruby-core:82291] [Bug #13793]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59556 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 059¢f260 - 08/10/2017 12:50 AM - nobu (Nobuyoshi Nakada)

compile.c: fix KW_SPLAT flag condition

e compile.c (compile_array_keyword_arg): fix the condition of
KW_SPLAT flag. splat is value node only without key node,

simple assoc argument is not. [ruby-core:82291] [Bug #13793]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59556 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 08/09/2017 08:14 AM - nobu (Nobuyoshi Nakada)

- Is duplicate of Bug #13791: "belongs_to': unknown keywords: required, anonymous_class (ArgumentError) since Revision 59519 added

#2 - 08/09/2017 04:07 PM - nobu (Nobuyoshi Nakada)

- Is duplicate of deleted (Bug #13791: "belongs_to': unknown keywords: required, anonymous_class (ArgumentError) since Revision 59519)

#3 - 08/09/2017 04:08 PM - nobu (Nobuyoshi Nakada)

- Related to Bug #13791: "belongs_to': unknown keywords: required, anonymous_class (ArgumentError) since Revision 59519 added

#4 - 08/09/2017 04:08 PM - nobu (Nobuyoshi Nakada)

- Related to Bug #10856: Splat with empty keyword args gives unexpected results added

#5 - 08/09/2017 06:00 PM - lugray (Lisa Ugray)

Minimal example:

def test (options={})
puts options

end

test **{foo: :bar}

#6 - 08/10/2017 12:50 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed

Applied in changeset trunk|r59556.
KW_SPLAT flag. splat is value node only without key node,

simple assoc argument is not. [ruby-core:82291] [Bug #13793]

07/16/2025

22


bugs.ruby-lang.org/issues/13793
https://bugs.ruby-lang.org/issues/13793
http://www.tcpdf.org

